package com.tencent.flutter_integration;

import android.content.Context;
import android.util.Log;

import java.lang.reflect.Method;

import io.flutter.embedding.engine.FlutterEngine;
import io.flutter.embedding.engine.dart.DartExecutor;

public class FlutterIntegrationManager {

    private static volatile FlutterIntegrationManager mManager;

    public FlutterIntegrationEngineContainer container = new FlutterIntegrationEngineContainer();

    public static FlutterIntegrationManager sharedInstance() {
        if (mManager == null) {
            synchronized (FlutterIntegrationManager.class) {
                if (mManager == null) {
                    mManager = new FlutterIntegrationManager();
                }
            }
        }
        return mManager;
    }

    public void initEngine(Context context) {
        if (container.flutterEngine == null) {
            FlutterEngine flutterEngine = new FlutterEngine(context);
            flutterEngine.getDartExecutor().executeDartEntrypoint(
                DartExecutor.DartEntrypoint.createDefault()
            );

            container.flutterEngine = flutterEngine;

            try {
                Class clz = Class.forName("io.flutter.plugins.GeneratedPluginRegistrant");
                Method method = clz.getDeclaredMethod("registerWith", FlutterEngine.class);
                method.invoke(null, flutterEngine);
            } catch (Throwable t) {
                Log.i("flutter_integration", t.toString());
            }
        }
    }
}
